#include <iostream>
using namespace std;

const int MAXLOG = 24;

struct node
{
    int ch[2];
    int sze, cnt;
} Tree[1 << MAXLOG];
int p; //模拟一个内存池,这是对应的顶。

void updata(int x, int offset) // 插入/删除 offset个x,插入正,删除负
{
    int now = 0; //0是根
    for (int i = MAXLOG - 1; i >= 0; i--)
    {
        bool now_bit = ((x & (1 << i)) != 0); //第i位的数值
        if (Tree[now].ch[now_bit] == 0)       //指向空,需要分配子节点
            Tree[now].ch[now_bit] = ++p;
        now = Tree[now].ch[now_bit];
        Tree[now].sze += offset; //这条子树链上的节点都需要
    }
    Tree[now].cnt += offset; //跑到叶子节点了
}

int get_rank(int x) //获取比x小的数的数量,不包括本身
{
    int now = 0; //0是根
    int ans = 0;
    for (int i = MAXLOG - 1; i >= 0; i--)
    {
        bool now_bit = ((x & (1 << i)) != 0); //第i位的数值
        if (now_bit == 1)                     //处于大的那一边
            ans += Tree[Tree[now].ch[0]].sze; //把比自己小的那些加上
        now = Tree[now].ch[now_bit];
        if (now == 0) //别忘了,这里的0是空的意思
            break;
    }
    return ans;
}

int get_kth(int k) //通过排名大小
{
    int now = 0; //0是根
    int ans = 0;
    for (int i = MAXLOG - 1; i >= 0; i--)
    {
        int temp = Tree[Tree[now].ch[0]].sze; //看看自己前面有多少
        if (k <= temp)                        //还在更前面
            now = Tree[now].ch[0];
        else //在自己后面
        {
            k -= temp; //更新相对在右子树的位置
            now = Tree[now].ch[1];
            ans |= (1 << i); //可以确定这一位是1
        }
        if (now == 0) //别忘了,这里的0是空的意思
            break;
    }
    return ans;
}

int pre(int x)
{
    return get_kth(get_rank(x));
}

int nxt(int x)
{
    return get_kth(get_rank(x + 1) + 1);
}

int main()
{
    int n;
    cin >> n;
    const int N = 1e7;
    while (n--)
    {
        int opt, val;
        cin >> opt >> val;
        switch (opt)
        {
        case 1:
            updata(val + N, 1); //防止负数
            break;
        case 2:
            updata(val + N, -1);
            break;
        case 3:
            cout << get_rank(val + N) + 1 << endl;
            break;
        case 4:
            cout << get_kth(val) - N << endl;
            break;
        case 5:
            cout << pre(val + N) - N << endl;
            break;
        case 6:
            cout << nxt(val + N) - N << endl;
            break;
        }
    }
    return 0;
}